#include <pic.h>				// pic specific identifiers
#include <stdio.h>				// New include file..
#define _XTAL_FREQ  4000000		// Xtal speed
__CONFIG(0x3D18);				// Config bits

#define RS232_PORT	PORTB			// RS232 port configuration
#define RS232_TRIS	TRISB
#define RX			RB7
#define TX			RB6
#define BAUD		84				// 1/9600 = 104us ( 20us for loop and math)
#define START_BIT	BAUD / 2		// half bit

		// Required prototypes

void Serinit(void), Serout(unsigned char ch), SerStringC(const char* str);
unsigned char Serin(void);

void main(void)							// program entry
	{
	CMCON = 0x7;						// Comparitors off
	__delay_ms(150);

	Serinit();							// Initalise screen
	SerStringC("N.GOODWINS TUTORIAL IN C.. ");

	while(1)							// endless Loop
		{
		}
	}

void SerStringC(const char* str)
	{
	while(*str != 0)
		Serout(*str++);
	}

void Serinit()
	{
	RS232_TRIS = 0b10000000;			// RS232  port
	TX = 1;
	}

unsigned char Serin()
unsigned char Serin()					// wait and get a byte on the serial
	{
	char index, ch=0;
	while(1)
		{
		while(RX);						// wait for start bit
		__delay_us(START_BIT);			// Half bit delay
		if(!RX)							// still start?
			{
			__delay_us(BAUD);				// bit delay
			for(index = 0;index<7;index++)
				{
				if(RX)						// bit or no bit
					ch+=0x80;				// add MSB
				__delay_us(BAUD);			// bit delay
				ch>>=1;						// shift along
				}							// until done
			if(RX) ch+=0x80;				// last bit
			return ch;						// return character
			}								// not bothered about the stop bit
		}
	}

void Serout( unsigned char ch)
	{
	char index;
	TX = 0;									// send a start bit
	__delay_us(BAUD);
	for(index = 0; index<8 ; index++)		// send the rest
		{
		if(ch & 0x1)						// test bit
			TX = 1;							// send high
		else
			TX = 0;							// send low
		__delay_us(BAUD);					// bit delay
		ch >>= 1;
		}
	TX = 1;									// send a stop bit
	__delay_us(BAUD);
	}


